/*===========================================================================
//
//	callcons.S
//
//
//===========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s): 	 hmt
// Contributors: hmt,
//               Gaisler Research (Konrad Eisele<eiselekd@web.de>) (fpu support)
// Date:	 1999-02-20
// Purpose:	 
// Description:	 callcons.S
//
//####DESCRIPTIONEND####
//
//=========================================================================*/

#include <pkgconf/system.h>

! special treatment for CYGHWR_HAL_SPARC_FLAT case, otherwise hal_zero_bss will clear return address
! i7, o7 is saved on top off stack, temporarily

	.text
        .global cyg_hal_start
        .extern hal_board_prestart 
        .extern hal_zero_bss
        .extern cyg_hal_invoke_constructors
        .extern hal_board_poststart
        .extern hal_copy_data
        
cyg_hal_start:
	add	%sp, -120, %sp			! Add 8bytes for temporary storage of i7 and o7
        st	%i7, [%sp+120]
	st	%o7, [%sp+4+120]
       
        call  hal_board_prestart 
        nop

#ifdef CYG_HAL_STARTUP_ROM
        ! Copy data from ROM to RAM 
        call hal_copy_data
        nop
#endif
        call  hal_zero_bss
        nop
        call  cyg_hal_invoke_constructors
        nop 
        call  hal_board_poststart
        nop 

	ld	[%sp+120], %i7
	ld	[%sp+4+120], %o7
        retl
	add	%sp, 120, %sp

       
// EOF callcons.S





#if 0
/* Implement BSS cleaing and DATA copying
 *
 * See linker script for symbols,
 *   __rom_data_start
 *   __ram_data_start
 *   __ram_data_end
 *   __bss_start
 *   __bss_end
 *   
 */

#ifdef CYG_HAL_STARTUP_ROM
/* Copy .data Section from flash to sram */
	.extern __rom_data_start
	.extern __ram_data_start
	.extern __ram_data_end
copy_data_section:
	set     __ram_data_start, %o0	! Destination
	set     __rom_data_start, %o1	! Source
	set     __ram_data_end, %o4	! End
continue_copying_data:
	cmp    %o4, %o0
	beq    clear_bss_section
	/* Copy 8 bytes */
	ldd    [%o1], %o2
	std    %o2, [%o0]
	add    %o0,8,%o0
	b      continue_copying_data
	add    %o1,8,%o1
#endif

/* Clear bss section in sram */
clear_bss_section:
/* Copy .data Section from flash to sram */
	.extern __bss_start
	.extern __bss_end
clear_bss_section:
	set     __bss_start, %o0	! Destination
	set     __bss_end-8, %o1	! End
	clr	%g1
continue_clearing_bss:
	cmp    %o1, %o0
	beq    done_initing_bss_and_data
	/* clear 8 bytes */
	std    %g0,[%o0]
	b      continue_clearing_bss
	add    %o0,8,%o0

done_initing_bss_and_data:
#endif
