// ====================================================================
//
//	HAL bootup platform-oriented code (assembler)
//
// ====================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
// ====================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s): 	        Gaisler Research, (Konrad Eisele<eiselekd@web.de>)
// Contributors:	
// Date:	        1999-02-01
// Purpose:	        Bootup code, platform oriented.
// Description:
//
//####DESCRIPTIONEND####
//
// ====================================================================

#include <pkgconf/system.h>	
#include <pkgconf/hal.h>
#include <cyg/hal/hal_amba.h>
#include <pkgconf/hal_sparc_leon3.h>

/* Calculate scaler register value from default baudrate */
#define CYGNUM_HAL_GRLIB_APBUART_SCALER \
 ((((CYGNUM_HAL_GRLIB_FREQ*10)/(CYGNUM_HAL_GRLIB_APBUART_BAUD*8))-5)/10)

!unsigned int ahbslv_scan(register unsigned int vendor,register unsigned int driver) {
!  register unsigned int conf, mbar,i, *confp;
!  register unsigned int cfg_area = (unsigned int ) (LEON3_IO_AREA | LEON3_CONF_AREA | LEON3_AHB_SLAVE_CONF_AREA);
!  for (i = 0; i < LEON3_AHB_SLAVES; i++) 
!  {
!    confp = (unsigned int*)(cfg_area + (i * LEON3_AHB_CONF_WORDS * 4));
!    conf = *confp;
!    //mbar = *(unsigned int*)(i * LEON3_AHB_CONF_WORDS+ (4 * 4));
!    if ((amba_vendor(conf) == vendor) && (amba_device(conf) == driver)) {
!      return (unsigned int)confp;
!    }
!  }
!  return 0;
!}
        
	.section	".text"
	.align 4
ahbslv_scan:
	mov	%o0, %g1
	mov	-2048, %o5
	mov	0, %o3
	sll	%o3, 5, %o0
.LL11:
	add	%o5, %o0, %o4
	ld	[%o5+%o0], %o2
	srl	%o2, 24, %o0
	cmp	%o0, %g1
	bne,a	.LL10
	add	%o3, 1, %o3
	srl	%o2, 12, %o0
	and	%o0, 4095, %o0
	cmp	%o0, %o1
	be	.LL1
	mov	%o4, %o2
	add	%o3, 1, %o3
.LL10:
	cmp	%o3, 63
	bleu,a	.LL11
	sll	%o3, 5, %o0
	mov	0, %o2
.LL1:
	retl
	mov	%o2, %o0


!unsigned int apbslv_scan(register unsigned int base,register unsigned int vendor, register unsigned int driver) {
!  register unsigned int conf, mbar,i, *confp;
!  for (i = 0; i < LEON3_APB_SLAVES; i++) 
!  {
!    confp = (unsigned int*)(base + (i * LEON3_APB_CONF_WORDS * 4));
!    conf = *confp;
!    //mbar = *(unsigned int*)(i * LEON3_AHB_CONF_WORDS+ (4 * 4));
!    if ((amba_vendor(conf) == vendor) && (amba_device(conf) == driver)) {
!      return (unsigned int)confp;
!    }
!  }
!  return 0;
!}


         
	.section	".text"
	.align 4

apbslv_scan:
	mov	%o0, %g1
	mov	0, %o4
	sll	%o4, 3, %o0
.LL22:
	add	%g1, %o0, %o5
	ld	[%g1+%o0], %o3
	srl	%o3, 24, %o0
	cmp	%o0, %o1
	bne,a	.LL21
	add	%o4, 1, %o4
	srl	%o3, 12, %o0
	and	%o0, 4095, %o0
	cmp	%o0, %o2
	be	.LL12
	mov	%o5, %o3
	add	%o4, 1, %o4
.LL21:
	cmp	%o4, 15
	bleu,a	.LL22
	sll	%o4, 3, %o0
	mov	0, %o3
.LL12:
	retl
	mov	%o3, %o0



!unsigned int getbase(register unsigned int *mbar,register unsigned int iobase) {
!  register unsigned int conf = mbar[1];
!  return ((iobase & 0xfff00000) |
!          ((conf & 0xfff00000)>> 12)) & (((conf & 0x0000fff0) <<4) | 0xfff00000);
!  
!}
        
         
	.section	".text"
	.align 4

getbase:
	ld	[%o0+4], %o2
	sethi	%hi(-1048576), %o3
	and	%o1, %o3, %o1
	and	%o2, %o3, %o0
	srl	%o0, 12, %o0
	or	%o1, %o0, %o1
	sethi	%hi(64512), %o0
	or	%o0, 1008, %o0
	and	%o2, %o0, %o2
	sll	%o2, 4, %o2
	or	%o2, %o3, %o2
	and	%o1, %o2, %o1
	retl
	mov	%o1, %o0


! ************ LEON3 LOW LEVEL CPU initialization *************
! LOW level initialization.
! Initilizes CPU, IRQ controller and memory controller(s)
!

/* The base registers */
#define APBBASE     %g1
#define ABPCFGBASE  %g2
#define MCTRLBASE   %g3
#define SDCTRLBASE  %g4
#define DDRSPABASE  %g4
#define DDR2SPABASE %g4
#define IRQCTRLBASE %g5
#define RETADDR     %g7

	.global hal_sparc_leon_init_low
	.extern LEON3_APBUART_Regs,LEON3_GpTimer_Regs,LEON3_IrqCtrl_Regs
hal_sparc_leon_init_low:

	flush

#ifdef CYGPKG_HAL_SMP_SUPPORT
        !lda [%g0] 2, %g1           ! init cache
	!set 0x800000, %g2          ! snooping enable
        !or  %g2, %g1, %g2
 
        !set	0x800000, %g2   ! snooping,disable cache for test
          
        !sta %g2, [%g0] 2          ! init cache
       
	!set	0x81000f, %g2   ! snooping enable
        !set	0x800000, %g2   ! snooping enable
#else
#if defined(CYGNUM_HAL_GRLIB_BOOT_CACHE) && !defined(CYGNUM_HAL_GRLIB_DSU)
	clr	%g2

	! Set Instruction Cache Parameters
#ifdef CYGNUM_HAL_GRLIB_CACHE_I
	or	%g2, 0x3, %g2
#ifdef CYGNUM_HAL_GRLIB_CACHE_I_BURST
	set	0x10000, %g1
	or	%g2, %g1, %g2
#endif
#ifdef CYGNUM_HAL_GRLIB_CACHE_I_FREEZE
	or	%g2, 0x10, %g2
#endif
#endif /* CYGNUM_HAL_GRLIB_CACHE_I */

	! Set Data Cache Parameters
#ifdef CYGNUM_HAL_GRLIB_CACHE_D
	or	%g2, 0xc, %g2
#ifdef CYGNUM_HAL_GRLIB_CACHE_D_SNOOPING
	set	0x800000, %g1
	or	%g2, %g1, %g2
#endif
#ifdef CYGNUM_HAL_GRLIB_CACHE_D_FREEZE
	or	%g2, 0x20, %g2
#endif
#endif /* CYGNUM_HAL_GRLIB_CACHE_D */

	sta	%g2, [%g0] 2	! init cache
#endif /* defined(CYGNUM_HAL_GRLIB_BOOT_CACHE) && !defined(CYGNUM_HAL_GRLIB_DSU) */

#endif

	mov	%g0, %y
	clr	%g1
	clr	%g2
	clr	%g3
	clr	%g4
	clr	%g5
	clr	%g6
	mov	%o7,RETADDR

	! LEON3FT CPUs need it's registers cleared so that reading them
	! without ever writing them doesn't result in a trap.
#ifdef CYGNUM_HAL_GRLIB_LEON3FT
	rd	%psr, %g6
	mov	%asr17, %g5
	and	%g5, 0x1f, %g5
clear_curr_window:
	mov	%g0, %l0
	mov	%g0, %l1
	mov	%g0, %l2
	mov	%g0, %l3
	mov	%g0, %l4
	mov	%g0, %l5
	mov	%g0, %l6
	mov	%g0, %l7
	mov	%g0, %o0
	mov	%g0, %o1
	mov	%g0, %o2
	mov	%g0, %o3
	mov	%g0, %o4
	mov	%g0, %o5
	mov	%g0, %o6
	mov	%g0, %o7
	subcc	%g5, 1, %g5
	bge	clear_curr_window
	save				! Change to next Window
	
	wr	%g6, %psr		! Reset CPW to starting window
	nop				! Wait 3clks until PSR settled
	nop
	nop
	clr	%g5
	clr	%g6	
#endif

	! *************** AHB/APB **************
	! Find AHB -> APB Bridge
	set VENDOR_GAISLER, %o0
	set GAISLER_APBMST, %o1
	call ahbslv_scan
	nop

	cmp %g0,%o0
	be hal_sparc_leon3_low_error
	 nop

	ld [%o0+16],%g1
	set LEON3_IO_AREA,%o0
	and %g1,%o0,APBBASE            !g1: apb base

	set LEON3_CONF_AREA,%o0
	or APBBASE,%o0,ABPCFGBASE      !g2: apb conf base
	
	! *********** irq *****************
	! Mask out all IRQs
	mov ABPCFGBASE,%o0
	set VENDOR_GAISLER, %o1
	set GAISLER_IRQMP,%o2
	call apbslv_scan
	 nop
	cmp %g0,%o0
	be hal_sparc_leon3_low_error
	 nop
        
	call getbase
	 mov APBBASE,%o1

	mov	%o1, IRQCTRLBASE
	
	st	%g0, [IRQCTRLBASE + 0x0]  !irq pri   
	st	%g0, [IRQCTRLBASE + 0x4]  !irq pend  
	st	%g0, [IRQCTRLBASE + 0x8]  !irq force 
	st	%g0, [IRQCTRLBASE + 0xC]  !irq clear
	st	%g0, [IRQCTRLBASE + 0x40]  !irq mask

	! Scan and setup memory controllers
hal_sparc_leon3_memory_ctrl_setup:
	
	! ************ mctrl ************
#if defined(CYGNUM_HAL_GRLIB_BOOT_MCTRL) && !defined(CYGNUM_HAL_GRLIB_DSU)
        mov	ABPCFGBASE,%o0
        set	VENDOR_ESA, %o1
        set	ESA_MCTRL,%o2
        call	apbslv_scan
         nop
        cmp	%g0,%o0
        be	LL1mctlsdram				! No MCTRL found, search for SDRAM controller
         nop

        call	getbase
         mov	APBBASE,%o1

        mov	%o1,MCTRLBASE				! mctrl base address

	set	CYGNUM_HAL_GRLIB_MCTRL_CFG1, %o0	! Load memory config register 1
	ld	[%o1+0x00], %o2
	and	%o2, 0x300, %o2
	or	%o0, %o2, %o0
	st	%o0, [%o1 + 0x00]
	
	set	CYGNUM_HAL_GRLIB_MCTRL_CFG2, %o0	! Load memory config register 2
	st	%o0, [%o1 + 0x04]			! only for prom version, else done by "dumon -i"

	set	CYGNUM_HAL_GRLIB_MCTRL_CFG3, %o0	! Init FT register
	st	%o0, [%o1 + 0x08]
	ld	[%o1 + 0x08], %o0
	srl	%o0, 30, %o0
	andcc	%o0, 3, %g6
	bne,a	LL1mctlsdram				! Continue, in case of multiple memory controllers
	mov	%g0, %asr16				! clear err_reg
#endif

	! ************ gaisler sdram mctrl ************
LL1mctlsdram:
#if defined(CYGNUM_HAL_GRLIB_BOOT_SDCTRL) && !defined(CYGNUM_HAL_GRLIB_DSU)
        set VENDOR_GAISLER, %o0
        set GAISLER_SDCTRL, %o1
        call ahbslv_scan
        nop
        
        cmp %g0,%o0
        be LL1ddr2spa					! assuming sram/prom ctrl
         nop

        ld [%o0+16+4],SDCTRLBASE			! get io bar
        set LEON3_IO_AREA,%o0
        and SDCTRLBASE,%o0,SDCTRLBASE
        srl SDCTRLBASE,12,SDCTRLBASE
        or  SDCTRLBASE,%o0,SDCTRLBASE


        set	CYGNUM_HAL_GRLIB_SDCTRL_CFG1, %o0
        st	%o0, [SDCTRLBASE + 0x100]
	b       hal_sparc_leon3_low_end			! Assume no DDR/DDR2 SDRAM controller
	 nop
#endif
        ! ************ gaisler DDR2 ctrl (DDR2SPA) ************
LL1ddr2spa:
#if defined(CYGNUM_HAL_GRLIB_BOOT_DDR2) && !defined(CYGNUM_HAL_GRLIB_DSU)

	set VENDOR_GAISLER, %o0
	set GAISLER_DDR2SP, %o1
	call ahbslv_scan
	 nop

	cmp %g0,%o0
	be LL1ddrspa					! Scan for DDR controller
	 nop

	ld [%o0+16+4],DDR2SPABASE			! get io bar
	set LEON3_IO_AREA,%o0
	and DDR2SPABASE,%o0,DDR2SPABASE
	srl DDR2SPABASE,12,DDR2SPABASE
	or  DDR2SPABASE,%o0,DDR2SPABASE

	set     CYGNUM_HAL_GRLIB_DDR2_CFG1, %o0
	st      %o0, [DDR2SPABASE]			! Set DDR2CFG1
	set     CYGNUM_HAL_GRLIB_DDR2_CFG3, %o0
	st      %o0, [DDR2SPABASE+0x08]			! Set DDR2CFG3
	b       hal_sparc_leon3_low_end			! Assume no DDR SDRAM controller
	 nop
#endif

	! ************ gaisler DDR ctrl (DDRSPA) ************
LL1ddrspa:
#if defined(CYGNUM_HAL_GRLIB_BOOT_DDR) && !defined(CYGNUM_HAL_GRLIB_DSU)

	set VENDOR_GAISLER, %o0
	set GAISLER_DDRSP, %o1
	call ahbslv_scan
	 nop

	cmp %g0,%o0
	be hal_sparc_leon3_low_end			! assuming sram/prom ctrl
	 nop

	ld [%o0+16+4],DDRSPABASE			! get io bar
	set LEON3_IO_AREA,%o0
	and DDRSPABASE,%o0,DDRSPABASE
	srl DDRSPABASE,12,DDRSPABASE
	or  DDRSPABASE,%o0,DDRSPABASE

	set     CYGNUM_HAL_GRLIB_DDR_CFG1, %o0
	st      %o0, [DDRSPABASE]			! Set SDCTRL
#endif

hal_sparc_leon3_low_end:
#ifdef CYGNUM_HAL_GRLIB_LEON3FT
	! Implement: Clear all RAM memory here, not BSS and DATA though.
#endif

	! Clear/init BSP specific data that is outside .data and .bss
	sethi	%hi(LEON3_IrqCtrl_Regs),%o0
	st	IRQCTRLBASE, [%o0+%lo(LEON3_IrqCtrl_Regs)]
	
	sethi	%hi(LEON3_APBUART_Regs),%o0
	st	%g0, [%o0+%lo(LEON3_APBUART_Regs)]
	
	sethi	%hi(LEON3_GpTimer_Regs), %o0
	st	%g0, [%o0+%lo(LEON3_GpTimer_Regs)]
	

hal_sparc_leon3_low_return_low_init:
	mov	RETADDR,%o7
	clr	RETADDR
	retl
	 nop

hal_sparc_leon3_low_error:
	ba hal_sparc_leon3_low_error
	nop

!
!
! ************ LEON3 CPU init *************
! Memory controller has been setup when we
! enter here, however the stack has not been 
! setup yet.

	.global hal_sparc_leon_init
	.extern LEON3_APBUART_Regs
hal_sparc_leon_init:
        mov	%o7, %g7
	
        set VENDOR_GAISLER, %o0
        set GAISLER_APBMST, %o1
        call ahbslv_scan
        nop
        
        cmp %g0,%o0
        be .goonhardreset
         nop
        
        ld [%o0+16],%g1
        set LEON3_IO_AREA,%o0
        and %g1,%o0,APBBASE            !g1: apb base

        set LEON3_CONF_AREA,%o0
        or APBBASE,%o0,ABPCFGBASE      !g2: apb conf base
	
	! *********** timer *****************
	
        mov ABPCFGBASE,%o0
        set VENDOR_GAISLER, %o1
        set GAISLER_GPTIMER,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .goonhardreset
         nop
        
        call getbase
         mov APBBASE,%o1
#ifndef CYGNUM_HAL_GRLIB_DSU
	set	(CYGNUM_HAL_GRLIB_FREQ/1000+500)/1000, %o0		! Load timer scaler register
	sub	%o0, 1, %o0
  	st	%o0, [%o1 + 0x00] ! scaler
  	st	%o0, [%o1 + 0x04] ! scaler reload
#endif

hal_sparc_leon3_apbuart_setup:
        mov ABPCFGBASE,%o0
        set VENDOR_GAISLER, %o1
        set GAISLER_APBUART,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .goonhardreset
         nop

        call getbase
         mov APBBASE,%o1

#define UARTBASE %g5
        mov %o1,UARTBASE             !uart base address
        
        !########################################################
        ! initialization: protect g5 (uartbase)

	ld	[UARTBASE + 0x08], %o0
	andn	%o0, 0xc, %o0					! Remove Interrupts
	or	%o0, 0x3, %o0					! Enable RX/TX

#if defined(CYGNUM_HAL_GRLIB_BOOT_APBUART) && !defined(CYGNUM_HAL_GRLIB_DSU)
	set	CYGNUM_HAL_GRLIB_APBUART_SCALER, %g2		! Load UART scaler register
	st	%g2, [UARTBASE + 0x0c]				! uart scalar

	andn	%o0, 0xf0, %o0					! Override default parameters (Flow control, Parity, Loopback)

#ifdef CYGNUM_HAL_GRLIB_APBUART_LOOPBACK
	or	%o0, 0x80, %o0
#endif

#ifdef CYGNUM_HAL_GRLIB_APBUART_FLOWCTRL
	or	%o0, 0x40, %o0
#endif

#ifdef CYGNUM_HAL_GRLIB_APBUART_PARITY_ODD
	or	%o0, 0x30 , %o0
#endif
#ifdef CYGNUM_HAL_GRLIB_APBUART_PARITY_EVEN
	or	%o0, 0x20, %o0
#endif

#endif

	st	%o0, [UARTBASE + 0x08]
        
	sethi	%hi(LEON3_APBUART_Regs), %o0			! Connect console to this APBUART
	st	UARTBASE, [%o0+%lo(LEON3_APBUART_Regs)]		! Note that it will be overwritten if DATA/BSS is initialized later
	
	!#######################################################
	! end
	
#if CYGHWR_HAL_SPARC_MULTIPLE_VECTOR_TRAPPING
#ifdef CYG_HAL_STARTUP_RAM
#if !defined(CYGPKG_HAL_SMP_SUPPORT)
        ! then copy the branch instructions into the vector
	rd	%tbr, %g1
	andn	%g1, 0xfff, %g1		! clear non-address bits
	sethi	%hi(real_vector_instructions), %l0
	or	%l0, %lo(real_vector_instructions), %l0
	
	ld	[ %l0 ], %l1
	st	%l1, [ %g1 ]		! into the vector
	ld	[ %l0 + 4 ], %l1
	st	%l1, [ %g1 + 4 ]	! into the vector
#endif
#endif
#endif
  	
.goonhardreset:

#ifndef CYGNUM_HAL_GRLIB_DSU      
! Set up Stack pointer and Frame Pointer
	set	CYGNUM_HAL_GRLIB_STACK, %fp
	andn	%fp, 0x0f, %fp
	sub	%fp, 64, %sp
#endif

	mov	RETADDR,%o7
	clr	RETADDR
	retl
	 nop
		
	
