//===========================================================================
//
//      hal_amba.c
//
//      SPARC Architecture LEON3-specific private variables
//
//===========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Gaisler Research (Konrad Eisele<eiselekd@web.de>)
// Contributors: 
// Date:         2004
// Purpose:      private amba for LEON3 processor.
//              
//####DESCRIPTIONEND####
//
//===========================================================================

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <cyg/hal/hal_leon3.h>
#include <cyg/infra/diag.h>
#include <cyg/hal/hal_amba.h>
#include <cyg/infra/cyg_trac.h>         // tracing macros
#include <cyg/hal/hal_clock.h> // which includes this file

extern volatile LEON3_GpTimer_Regs_Map *LEON3_GpTimer_Regs;

void hal_sparc_leon3_clock_init(cyg_uint32 period) {
  cyg_hal_sparc_clock_period = (period);                        \
  
  if (LEON3_GpTimer_Regs) {
    
    LEON3_BYPASS_STORE_PA(&LEON3_GpTimer_Regs ->e[0].val,(period));
    LEON3_BYPASS_STORE_PA(&LEON3_GpTimer_Regs ->e[0].rld,(period));
    LEON3_BYPASS_STORE_PA(&LEON3_GpTimer_Regs ->e[0].ctrl,0);
    
    LEON3_BYPASS_STORE_PA(&LEON3_GpTimer_Regs ->e[0].ctrl,
			  LEON3_GPTIMER_EN |
			  LEON3_GPTIMER_RL |
			  LEON3_GPTIMER_IRQEN |
			  LEON3_GPTIMER_LD);
  } else {
    diag_printf("Clock init failed");
  }
}

cyg_uint32 hal_sparc_leon3_clock_read(void) {
  if (LEON3_GpTimer_Regs) {
    return LEON3_BYPASS_LOAD_PA(&LEON3_GpTimer_Regs ->e[0].val);
  }
  return 1;
}

extern unsigned long LEON3_GpTimer_Irq;
cyg_uint32 hal_sparc_leon3_clock_irqnr(void) {
  if (!LEON3_GpTimer_Irq) {
    amba_init();
  }
  return LEON3_GpTimer_Irq;
}
